<template>
  <v-card style="position: fixed; min-width: 30vw; max-width: 30vw;">
    <v-card-title class="headline mb-0 pb-1">
      Task list
    </v-card-title>
    <v-card-text class="mt-0 pt-0">
      <span class="grey--text subtitle-1">Click on a list to view tasks</span>
    </v-card-text>
    <v-divider v-if="taskList && taskList.length > 0"></v-divider>
    <v-list style="max-height: 50vh; overflow-y: scroll" v-if="taskList && taskList.length > 0">
      <v-list-tile
        v-for="item in taskList"
        :key="item.id"
        @click="loadTask(item)"
        :class="isCurrent(item)"
      >
        <v-list-tile-avatar>
          <v-avatar
            size="25px"
            :class="item.color"
          ></v-avatar>
        </v-list-tile-avatar>
          <v-list-tile-title class="text-wrap">
            {{ item.title }}
          </v-list-tile-title>
          <div>
            <IconButton
              tip="Edit list"
              iconName="settings"
              :flat=true
              :small=true
              color="primary"
              :datas=item
              eventName="edit"
              v-on:edit="sendEvent('editList', $event)"
            />
          </div>
          <div>
            <IconButton
              tip="Delete list"
              iconName="delete"
              :flat=true
              :small=true
              color="error"
              :datas=item
              eventName="delete"
              v-on:delete="sendEvent('deleteList', $event)"
            />
          </div>
      </v-list-tile>
    </v-list>
    <v-divider></v-divider>
    <v-list>
      <v-list-tile
        @click="addList()"
      >
        <v-list-tile-title>
          Add a list
        </v-list-tile-title>
        <div class="pt-2">
          <v-icon color="grey lighten-1">add</v-icon>
        </div>
      </v-list-tile>
    </v-list>
  </v-card>
</template>

<script>
import TaskService from '@/services/TaskService'
import ErrorService from '@/services/ErrorService'
import IconButton from '@/components/Buttons/IconButton'

export default {
  name: 'Price',
  props: {
    taskList: {
      type: Array,
      required: true
    },
    current: {
      type: Number,
      required: false,
      default: 0
    }
  },
  components: {
    IconButton
  },
  data: () => ({
    taskService: new TaskService(),
    errorService: new ErrorService(),
    dialog: false
  }),
  methods: {
    loadTask: function (item) {
      this.$emit('load', item)
    },
    addList: function (item) {
      this.$emit('addList')
    },
    isCurrent: function (item) {
      if (item.id === this.current) {
        return 'currentList'
      } else {
        return ''
      }
    },
    sendEvent: function (name, task) {
      this.$emit(name, task)
    }
  }
}
</script>

<style>
.currentList {
  background-color: lightgray;
}
</style>
